
#if !defined(AFX_FLASHME_H__INCLUDED_)
#define AFX_FLASHME_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif

#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <commctrl.h>
#include "resource.h"


typedef LPVOID (*PROTO_ALLOCMEM)( ULONG, ULONG, ULONG, ULONG, LPDWORD );
PROTO_ALLOCMEM		NAND_AllocPhysMem;

typedef int (*PROTO_FREEMEM)( LPVOID );
PROTO_FREEMEM		NAND_FreePhysMem;

typedef int (*PROTO_NANDINIT)( LPVOID, ULONG );
PROTO_NANDINIT		NAND_Init;

typedef int (*PROTO_BADBLOCK)( ULONG );
PROTO_BADBLOCK		NAND_IsBlockBad;

typedef int (*PROTO_ERASEBLOCK)( ULONG );
PROTO_ERASEBLOCK	NAND_EraseBlock;

typedef int (*PROTO_READPAGE)( ULONG, LPVOID, ULONG, ULONG );
PROTO_READPAGE		NAND_ReadPage;

typedef int (*PROTO_WRITEPAGE)( ULONG, LPVOID, ULONG );
PROTO_WRITEPAGE		NAND_WritePage;

typedef int (*PROTO_READSPARE)( ULONG, LPVOID );
PROTO_READSPARE		NAND_ReadSpareData;

typedef int (*PROTO_WRITESPARE)( ULONG, LPVOID );
PROTO_WRITESPARE	NAND_WriteSpareData;

#define NAND_PAGE_SIZE			512
#define NAND_NROF_PAGES			32
#define NAND_NROF_BLOCKS		4096
#define NAND_BLOCK_SIZE			NAND_PAGE_SIZE * NAND_NROF_PAGES			//0x00004000		16k
#define NAND_OVERALL_SIZE		NAND_BLOCK_SIZE * NAND_NROF_BLOCKS			//0x04000000		64mb

struct _FLASHHEADER
{
	UCHAR	version;
	USHORT	crc16;
    UCHAR	flags;
	ULONG	start;
    ULONG	size;
    ULONG	reserved;
};
#define FLASHHEADER				struct _FLASHHEADER


LRESULT CALLBACK				WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
ULONG WINAPI					NAND_WorkerThread( LPVOID hWnd );
HMODULE							NAND_GetInterface();
USHORT							NAND_GetBlockCRC( UCHAR *data );
VOID							linux_old_calc_ecc( UCHAR *dat, UCHAR *ecc_code);

#endif // !defined(AFX_FLASHME_H__INCLUDED_)
